## mingw-w64-vulkanscenegraph-1.1.8-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(vsg
    VERSION 1.1.8
    DESCRIPTION "VulkanSceneGraph library"
    LANGUAGES CXX
)
set(VSG_SOVERSION 14)
SET(VSG_RELEASE_CANDIDATE 0)
set(Vulkan_MIN_VERSION 1.1.70.0)

set(VSG_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}" CACHE INTERNAL "Root source directory of VulkanSceneGraph.")
set(VSG_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}" CACHE INTERNAL "Root binary directory of VulkanSceneGraph.")

# create the version header
set(VSG_MAX_DEVICES 1 CACHE STRING "Set maximum number of vk/vsg::Device that are supported.")
set(VSG_VERSION_HEADER "${PROJECT_BINARY_DIR}/include/vsg/core/Version.h")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(vsgMacros)

vsg_setup_dir_vars()
vsg_setup_build_vars()


if (MSVC)
    # Increase Number of Sections in .Obj file
    add_compile_options(/bigobj)
endif()

if (VULKAN_SDK)
    message("Within VulkanSceneGraph cmake, setting VULKAN_SDK env var to " ${VULKAN_SDK})
    set(ENV{VULKAN_SDK} ${VULKAN_SDK})
endif()

find_package(Vulkan ${Vulkan_MIN_VERSION} REQUIRED)

find_package(Threads REQUIRED)

# Set the instrumentation level to compile into sources
set(VSG_MAX_INSTRUMENTATION_LEVEL 1 CACHE STRING "Set the instrumentation level to build into the VSG ibrary, 0 for off, 1 coarse grained, 2 medium, 3 fine grained." )

# Enable/disable shader compilation support that pulls in glslang
set(VSG_SUPPORTS_ShaderCompiler  1 CACHE STRING "Optional shader compiler support, 0 for off, 1 for enabled." )
if (VSG_SUPPORTS_ShaderCompiler)
    set(GLSLANG_MIN_VERSION "14" CACHE STRING "glslang 14 is the earliest version that we think installs itself properly on all platforms. Other platforms may be able to use an earlier version")
    find_package(glslang ${GLSLANG_MIN_VERSION} CONFIG)

    if (glslang_FOUND)
        set(FIND_DEPENDENCY_glslang "find_package(glslang ${GLSLANG_MIN_VERSION} CONFIG REQUIRED)")
    else()
        message(WARNING "glslang not found. ShaderCompile support disabled.")
        set(VSG_SUPPORTS_ShaderCompiler 0)
        set(FIND_DEPENDENCY_glslang "")
    endif()
else()
    set(FIND_DEPENDENCY_glslang "")
endif()

set(VSG_SUPPORTS_Windowing  1 CACHE STRING "Optional native windowing support providing a default implementation of vsg::Window::create(), 0 for off, 1 for enabled." )
if (VSG_SUPPORTS_Windowing)
    if (ANDROID)
        set(FIND_DEPENDENCY_WINDOWING "")
        find_library(AndroidLib android)
        if(CMAKE_SYSTEM_VERSION GREATER 24)
            find_library(AndroidNativeWindowLib nativewindow)
        endif()
    elseif (WIN32)
        set(FIND_DEPENDENCY_WINDOWING "")
        # just use native windowing
    elseif (APPLE)
        set(FIND_DEPENDENCY_WINDOWING "find_library(COCOA_LIBRARY Cocoa)\nfind_library(QUARTZCORE_LIBRARY QuartzCore)\n")
        find_library(COCOA_LIBRARY Cocoa)
        find_library(QUARTZCORE_LIBRARY QuartzCore)
    else()
        set(FIND_DEPENDENCY_WINDOWING "find_package(PkgConfig REQUIRED)\npkg_check_modules(xcb REQUIRED IMPORTED_TARGET xcb)\n")
        # just use Xcb for native windowing
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(xcb REQUIRED IMPORTED_TARGET xcb)
    endif()
endif()

# this line needs to be after the call to setup_build_vars()
configure_file("${VSG_SOURCE_DIR}/src/vsg/core/Version.h.in" "${VSG_VERSION_HEADER}")

vsg_add_target_clang_format(
    FILES
        ${VSG_SOURCE_DIR}/include/vsg/*/*.h
        ${VSG_SOURCE_DIR}/src/vsg/*/*.cpp
        ${VSG_SOURCE_DIR}/include/vsg/platform/unix/*.h
        ${VSG_SOURCE_DIR}/src/vsg/platform/unix/*.cpp
        ${VSG_SOURCE_DIR}/include/vsg/platform/win32/*.h
        ${VSG_SOURCE_DIR}/src/vsg/platform/win32/*.cpp
        ${VSG_SOURCE_DIR}/include/vsg/platform/android/*.h
        ${VSG_SOURCE_DIR}/src/vsg/platform/android/*.cpp
)
vsg_add_target_clobber()
vsg_add_target_cppcheck(
    SUPPRESSIONS_LIST
        "${VSG_SOURCE_DIR}/cmake/cppcheck-suppression-list.txt"
    FILES
        ${CMAKE_SOURCE_DIR}/include/vsg/*/*.h
        ${VSG_SOURCE_DIR}/src/vsg/*/*.cpp
        -I ${VSG_SOURCE_DIR}/include/
)
vsg_add_target_uninstall()
vsg_add_target_docs(
    FILES
        ${VSG_SOURCE_DIR}/include/vsg
)

# build_all_h build target to automatically generate the include/vsg/all.h from the headers in the include/vsg/* directories
add_custom_target(build_all_h
    COMMAND ${CMAKE_COMMAND} -DVSG_SOURCE_DIR=${VSG_SOURCE_DIR} -P ${VSG_SOURCE_DIR}/cmake/build_all_h.cmake
    COMMENT "update all.h to include all the include/vsg/*/*.h"
)
set_target_properties(build_all_h PROPERTIES FOLDER "VulkanSceneGraph")

# build_ShaderSets target automatically rebuilds the various built-in ShaderSets.
set(PBR_DEFINES
    -v \"\"
    -v "VSG_DIFFUSE_MAP"
    -v "VSG_EMISSIVE_MAP"
    -v "VSG_LIGHTMAP_MAP"
    -v "VSG_METALLROUGHNESS_MAP"
    -v "VSG_NORMAL_MAP"
    -v "VSG_SKINNING"
    -v "VSG_TWO_SIDED_LIGHTING"
    -v "VSG_WORKFLOW_SPECGLOSS"
    -v "VSG_DIFFUSE_MAP VSG_EMISSIVE_MAP"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP"
    -v "VSG_DIFFUSE_MAP VSG_METALLROUGHNESS_MAP"
    -v "VSG_DIFFUSE_MAP VSG_NORMAL_MAP"
    -v "VSG_DIFFUSE_MAP VSG_SKINNING"
    -v "VSG_DIFFUSE_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_WORKFLOW_SPECGLOSS"
    -v "VSG_LIGHTMAP_MAP VSG_METALLROUGHNESS_MAP"
    -v "VSG_LIGHTMAP_MAP VSG_NORMAL_MAP"
    -v "VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP"
    -v "VSG_METALLROUGHNESS_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_EMISSIVE_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP VSG_METALLROUGHNESS_MAP"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP VSG_NORMAL_MAP"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP"
    -v "VSG_DIFFUSE_MAP VSG_METALLROUGHNESS_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_NORMAL_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_LIGHTMAP_MAP VSG_NORMAL_MAP VSG_WORKFLOW_SPECGLOSS"
    -v "VSG_DIFFUSE_MAP VSG_EMISSIVE_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP VSG_NORMAL_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_EMISSIVE_MAP VSG_LIGHTMAP_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP"
    -v "VSG_DIFFUSE_MAP VSG_EMISSIVE_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_LIGHTMAP_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP VSG_WORKFLOW_SPECGLOSS"
    -v "VSG_DIFFUSE_MAP VSG_EMISSIVE_MAP VSG_LIGHTMAP_MAP VSG_METALLROUGHNESS_MAP VSG_NORMAL_MAP VSG_TWO_SIDED_LIGHTING"
    -v "VSG_DIFFUSE_MAP VSG_EMISSIVE_MAP VSG_LIGHTMAP_MAP VSG_NORMAL_MAP VSG_SPECULAR_MAP VSG_WORKFLOW_SPECGLOSS"
)

set(PHONG_DEFINES
    -v \"\"
    -v "VSG_BILLBOARD"
    -v "VSG_DIFFUSE_MAP"
    -v "VSG_BILLBOARD VSG_DIFFUSE_MAP"
)

set(FLAT_DEFINES
    -v \"\"
    -v "VSG_BILLBOARD"
    -v "VSG_DIFFUSE_MAP"
    -v "VSG_BILLBOARD VSG_DIFFUSE_MAP"
)

set(TEXT_DEFINES
    -v "CPU_LAYOUT"
    -v "CPU_LAYOUT BILLBOARD"
    -v "GPU_LAYOUT"
    -v "GPU_LAYOUT BILLBOARD"
)

add_custom_target(build_ShaderSets
    COMMAND vsgshaderset --pbr ${PBR_DEFINES} -o src/vsg/utils/shaders/pbr_ShaderSet.cpp --binary
    COMMAND vsgshaderset --phong ${PHONG_DEFINES}  -o src/vsg/utils/shaders/phong_ShaderSet.cpp --binary
    COMMAND vsgshaderset --flat ${FLAT_DEFINES} -o src/vsg/utils/shaders/flat_ShaderSet.cpp --binary
    COMMAND vsgshaderset --text ${TEXT_DEFINES}  -o src/vsg/text/shaders/text_ShaderSet.cpp  --binary
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "update built-in ShaderSets"
)
add_custom_target(build_simple_ShaderSets
    COMMAND vsgshaderset --pbr -o src/vsg/utils/shaders/pbr_ShaderSet.cpp
    COMMAND vsgshaderset --phong -o src/vsg/utils/shaders/phong_ShaderSet.cpp
    COMMAND vsgshaderset --flat -o src/vsg/utils/shaders/flat_ShaderSet.cpp
    COMMAND vsgshaderset --text -o src/vsg/text/shaders/text_ShaderSet.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "update built-in ShaderSets"
)

vsg_add_option_maintainer(
    PREFIX v
    RCLEVEL ${VSG_RELEASE_CANDIDATE}
)

#
# src directory contains all the source of the vsg library
#
add_subdirectory(src/vsg)

vsg_add_feature_summary()

=== src/vsg/CMakeLists.txt ===
# collect all the headers in the source directory
file(GLOB HEADERS ${VSG_SOURCE_DIR}/include/vsg/*.h ${VSG_SOURCE_DIR}/include/vsg/*/*.h)

# for out of source builds collect all the auto-generated headers in the build directory
if (NOT (${VSG_SOURCE_DIR} STREQUAL ${VSG_BINARY_DIR}))
    file(GLOB AUTOGENERATED_HEADERS ${VSG_BINARY_DIR}/include/vsg/*.h ${VSG_BINARY_DIR}/include/vsg/*/*.h)
    set(HEADERS ${HEADERS} ${AUTOGENERATED_HEADERS})
endif()

# set up the source files explicitly.
set(SOURCES

    core/Allocator.cpp
    core/IntrusiveAllocator.cpp
    core/Auxiliary.cpp
    core/ConstVisitor.cpp
    core/Data.cpp
    core/External.cpp
    core/MemorySlots.cpp
    core/Object.cpp
    core/Objects.cpp
    core/Visitor.cpp
    core/Version.cpp

    maths/maths_transform.cpp

    nodes/Group.cpp
    nodes/Geometry.cpp
    nodes/Node.cpp
    nodes/QuadGroup.cpp
    nodes/CullGroup.cpp
    nodes/CullNode.cpp
    nodes/LOD.cpp
    nodes/PagedLOD.cpp
    nodes/AbsoluteTransform.cpp
    nodes/MatrixTransform.cpp
    nodes/Transform.cpp
    nodes/VertexDraw.cpp
    nodes/VertexIndexDraw.cpp
    nodes/DepthSorted.cpp
    nodes/Layer.cpp
    nodes/Bin.cpp
    nodes/Switch.cpp
    nodes/StateGroup.cpp
    nodes/TileDatabase.cpp
    nodes/InstrumentationNode.cpp
    nodes/RegionOfInterest.cpp

    lighting/Light.cpp
    lighting/AmbientLight.cpp
    lighting/DirectionalLight.cpp
    lighting/PointLight.cpp
    lighting/SpotLight.cpp
    lighting/ShadowSettings.cpp
    lighting/HardShadows.cpp
    lighting/SoftShadows.cpp
    lighting/PercentageCloserSoftShadows.cpp

    commands/BindIndexBuffer.cpp
    commands/BindVertexBuffers.cpp
    commands/Commands.cpp
    commands/BlitImage.cpp
    commands/CopyImage.cpp
    commands/CopyImageToBuffer.cpp
    commands/CopyAndReleaseBuffer.cpp
    commands/CopyAndReleaseImage.cpp
    commands/ClearAttachments.cpp
    commands/ClearImage.cpp
    commands/PipelineBarrier.cpp
    commands/Event.cpp
    commands/NextSubPass.cpp
    commands/Dispatch.cpp
    commands/Draw.cpp
    commands/DrawIndirect.cpp
    commands/DrawIndexed.cpp
    commands/DrawIndexedIndirect.cpp
    commands/SetDepthBias.cpp
    commands/SetLineWidth.cpp
    commands/SetScissor.cpp
    commands/SetViewport.cpp
    commands/SetPrimitiveTopology.cpp
    commands/ResolveImage.cpp
    commands/ResetQueryPool.cpp
    commands/WriteTimestamp.cpp
    commands/BeginQuery.cpp
    commands/EndQuery.cpp
    commands/CopyQueryPoolResults.cpp
    commands/ExecuteCommands.cpp
    commands/CopyImageViewToWindow.cpp

    state/ArrayState.cpp
    state/BindDescriptorSet.cpp
    state/Buffer.cpp
    state/BufferInfo.cpp
    state/BufferView.cpp
    state/ComputePipeline.cpp
    state/DescriptorSet.cpp
    state/GraphicsPipeline.cpp
    state/Descriptor.cpp
    state/DescriptorBuffer.cpp
    state/DescriptorImage.cpp
    state/DescriptorTexelBufferView.cpp
    state/DescriptorSetLayout.cpp
    state/ShaderModule.cpp
    state/ShaderStage.cpp
    state/PipelineLayout.cpp
    state/Sampler.cpp
    state/ResourceHints.cpp
    state/StateCommand.cpp
    state/StateSwitch.cpp
    state/Image.cpp
    state/ImageInfo.cpp
    state/ImageView.cpp
    state/VertexInputState.cpp
    state/InputAssemblyState.cpp
    state/TessellationState.cpp
    state/ViewportState.cpp
    state/RasterizationState.cpp
    state/MultisampleState.cpp
    state/DepthStencilState.cpp
    state/ColorBlendState.cpp
    state/DynamicState.cpp
    state/ViewDependentState.cpp
    state/QueryPool.cpp
    state/PushConstants.cpp

    io/convert_utf.cpp
    io/FileSystem.cpp
    io/AsciiInput.cpp
    io/DatabasePager.cpp
    io/AsciiOutput.cpp
    io/BinaryInput.cpp
    io/BinaryOutput.cpp
    io/Input.cpp
    io/Logger.cpp
    io/Output.cpp
    io/Options.cpp
    io/ObjectFactory.cpp
    io/Path.cpp
    io/ReaderWriter.cpp
    io/VSG.cpp
    io/spirv.cpp
    io/tile.cpp
    io/glsl.cpp
    io/txt.cpp
    io/read.cpp
    io/write.cpp
    io/mem_stream.cpp

    text/CpuLayoutTechnique.cpp
    text/GpuLayoutTechnique.cpp
    text/Font.cpp
    text/StandardLayout.cpp
    text/Text.cpp
    text/TextGroup.cpp

    threading/Affinity.cpp
    threading/OperationThreads.cpp
    threading/DeleteQueue.cpp

    app/Camera.cpp
    app/CompileManager.cpp
    app/EllipsoidModel.cpp
    app/Viewer.cpp
    app/Window.cpp
    app/WindowAdapter.cpp
    app/WindowTraits.cpp
    app/Trackball.cpp
    app/CommandGraph.cpp
    app/SecondaryCommandGraph.cpp
    app/RenderGraph.cpp
    app/Presentation.cpp
    app/RecordAndSubmitTask.cpp
    app/TransferTask.cpp
    app/WindowResizeHandler.cpp
    app/View.cpp
    app/ViewMatrix.cpp
    app/ProjectionMatrix.cpp
    app/UpdateOperations.cpp
    app/RecordTraversal.cpp
    app/CompileTraversal.cpp

    raytracing/AccelerationGeometry.cpp
    raytracing/AccelerationStructure.cpp
    raytracing/BottomLevelAccelerationStructure.cpp
    raytracing/BuildAccelerationStructureTraversal.cpp
    raytracing/DescriptorAccelerationStructure.cpp
    raytracing/RayTracingPipeline.cpp
    raytracing/RayTracingShaderGroup.cpp
    raytracing/TopLevelAccelerationStructure.cpp
    raytracing/TraceRays.cpp

    meshshaders/DrawMeshTasks.cpp
    meshshaders/DrawMeshTasksIndirect.cpp
    meshshaders/DrawMeshTasksIndirectCount.cpp

    animation/Animation.cpp
    animation/AnimationGroup.cpp
    animation/AnimationManager.cpp
    animation/CameraAnimation.cpp
    animation/FindAnimations.cpp
    animation/Joint.cpp
    animation/JointSampler.cpp
    animation/MorphSampler.cpp
    animation/TransformSampler.cpp

    ui/UIEvent.cpp
    ui/ApplicationEvent.cpp
    ui/KeyEvent.cpp
    ui/TouchEvent.cpp
    ui/PointerEvent.cpp
    ui/ScrollWheelEvent.cpp
    ui/WindowEvent.cpp
    ui/RecordEvents.cpp
    ui/CollectEvents.cpp
    ui/ShiftEventTime.cpp
    ui/PlayEvents.cpp
    ui/PrintEvents.cpp
    ui/Keyboard.cpp

    vk/CommandBuffer.cpp
    vk/CommandPool.cpp
    vk/Context.cpp
    vk/DescriptorPool.cpp
    vk/DescriptorPools.cpp
    vk/Device.cpp
    vk/DeviceFeatures.cpp
    vk/DeviceMemory.cpp
    vk/DeviceExtensions.cpp
    vk/Fence.cpp
    vk/Framebuffer.cpp
    vk/Instance.cpp
    vk/InstanceExtensions.cpp
    vk/MemoryBufferPools.cpp
    vk/PhysicalDevice.cpp
    vk/Queue.cpp
    vk/RenderPass.cpp
    vk/Semaphore.cpp
    vk/Surface.cpp
    vk/Swapchain.cpp
    vk/ResourceRequirements.cpp

    utils/CommandLine.cpp
    utils/Builder.cpp
    utils/SharedObjects.cpp
    utils/ShaderSet.cpp
    utils/GraphicsPipelineConfigurator.cpp
    utils/ShaderCompiler.cpp
    utils/ComputeBounds.cpp
    utils/Intersector.cpp
    utils/Instrumentation.cpp
    utils/GpuAnnotation.cpp
    utils/LineSegmentIntersector.cpp
    utils/PolytopeIntersector.cpp
    utils/LoadPagedLOD.cpp
    utils/FindDynamicObjects.cpp
    utils/PropagateDynamicObjects.cpp
    utils/Profiler.cpp
)

# set up library dependencies
set(LIBRARIES PUBLIC
        Vulkan::Vulkan
        Threads::Threads
)

if (${VSG_SUPPORTS_ShaderCompiler})
    list(APPEND LIBRARIES PRIVATE glslang::glslang glslang::glslang-default-resource-limits glslang::SPIRV)
endif()

# Check for std::atomic
if(NOT MSVC AND NOT ANDROID AND NOT APPLE)
  include(CheckCXXSourceCompiles)

  check_cxx_source_compiles("
    #include <atomic>
    int main()
    {
        std::atomic_uint64_t a64(1);
        auto orig_value = a64.load();

        uint64_t new_value = 1;
        auto r = a64.compare_exchange_weak(orig_value, new_value);

        return 0;
    }"
    HAVE_CXX_ATOMIC_WITHOUT_LIB
  )
  if(NOT HAVE_CXX_ATOMIC_WITHOUT_LIB)
    find_library(CXX_ATOMIC_LIBRARIES NAMES atomic atomic.so.1 libatomic.so.1 REQUIRED)
    list(APPEND LIBRARIES ${CXX_ATOMIC_LIBRARIES})
  endif()
endif()

if (VSG_SUPPORTS_Windowing)
    if (ANDROID)
        set(HEADERS ${HEADERS} ${VSG_SOURCE_DIR}/include/vsg/platform/android/Android_Window.h)
        set(SOURCES ${SOURCES} platform/android/Android_Window.cpp)

        if(CMAKE_SYSTEM_VERSION GREATER 24)
            set(LIBRARIES ${LIBRARIES} PRIVATE ${AndroidLib} PRIVATE ${AndroidNativeWindowLib})
        else()
            set(LIBRARIES ${LIBRARIES} PRIVATE ${AndroidLib})
        endif()
    elseif (WIN32)
        set(SOURCES ${SOURCES} platform/win32/Win32_Window.cpp)
    elseif (IOS)
        set(HEADERS ${HEADERS}
            ${VSG_SOURCE_DIR}/include/vsg/platform/ios/iOS_Window.h
            ${VSG_SOURCE_DIR}/include/vsg/platform/ios/iOS_ViewController.h
        )
        set(SOURCES ${SOURCES}
            platform/ios/iOS_Window.mm
            platform/ios/iOS_ViewController.mm
        )
        set(LIBRARIES ${LIBRARIES} PRIVATE ${UIKIT_LIBRARY} PRIVATE ${QUARTZCORE_LIBRARY})
    elseif (APPLE)
        set(SOURCES ${SOURCES} platform/macos/MacOS_Window.mm)
        set(LIBRARIES ${LIBRARIES} PRIVATE ${COCOA_LIBRARY} PRIVATE ${QUARTZCORE_LIBRARY})
    else()
        set(SOURCES ${SOURCES} platform/xcb/Xcb_Window.cpp)
        set(LIBRARIES ${LIBRARIES} PRIVATE PkgConfig::xcb)
    endif()
endif()

add_library(vsg ${HEADERS} ${SOURCES})

# add definitions to enable building VulkanSceneGraph as part of submodule
add_library(vsg::vsg ALIAS vsg)
set(vsg_FOUND TRUE CACHE INTERNAL "vsg found.")
set(CMAKE_DISABLE_FIND_PACKAGE_vsg TRUE CACHE INTERNAL "Disable find_package(vsg) as it's not necessary.")


set_target_properties(vsg PROPERTIES FOLDER "VulkanSceneGraph")
if(MSVC)
    # ensure the libraries are all built in the lib directory
    macro(SET_OUTPUT_DIR_PROPERTY TARGET_TARGETNAME RELATIVE_OUTDIR)
        # Global properties (All generators but VS & Xcode)
        set_target_properties(${TARGET_TARGETNAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY "${OUTPUT_LIBDIR}/${RELATIVE_OUTDIR}")
        set_target_properties(${TARGET_TARGETNAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${OUTPUT_LIBDIR}/${RELATIVE_OUTDIR}")
        set_target_properties(${TARGET_TARGETNAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${OUTPUT_LIBDIR}/${RELATIVE_OUTDIR}")

        # Per-configuration property (VS, Xcode)
        foreach(CONF ${CMAKE_CONFIGURATION_TYPES})        # For each configuration (Debug, Release, MinSizeRel... and/or anything the user chooses)
            string(TOUPPER "${CONF}" CONF)                # Go uppercase (DEBUG, RELEASE...)

            # We use "FILE(TO_CMAKE_PATH", to create nice looking paths
            set_target_properties(${TARGET_TARGETNAME} PROPERTIES "ARCHIVE_OUTPUT_DIRECTORY_${CONF}" "${OUTPUT_LIBDIR}/${RELATIVE_OUTDIR}")
            set_target_properties(${TARGET_TARGETNAME} PROPERTIES "RUNTIME_OUTPUT_DIRECTORY_${CONF}" "${OUTPUT_LIBDIR}/${RELATIVE_OUTDIR}")
            set_target_properties(${TARGET_TARGETNAME} PROPERTIES "LIBRARY_OUTPUT_DIRECTORY_${CONF}" "${OUTPUT_LIBDIR}/${RELATIVE_OUTDIR}")
        endforeach()
    endmacro()

    SET_OUTPUT_DIR_PROPERTY(vsg "")

    option(ENABLE_MP_FLAG "Turning on this option will add the multi-processor flag in MSVC for VSG and its included projects" ON)

    if(ENABLE_MP_FLAG)
        target_compile_options(vsg PRIVATE "/MP")
    endif()

    option(DISABLE_CHECKED_ITERATORS "Turning on this option will disable checked iterators in debug mode for visual studio. All imported projects must adhere to this requirement" OFF)

    if(DISABLE_CHECKED_ITERATORS)
        target_compile_definitions(vsg PUBLIC "_ITERATOR_DEBUG_LEVEL=0")
    endif()

endif()


# place header and source files into group folders to help IDE's present the files in a logical manner
function(ASSIGN_SOURCE_GROUPS GROUP_NAME ROOT_FOLDER)
    foreach(FILE IN ITEMS ${ARGN})
        if (IS_ABSOLUTE "${FILE}")
            file(RELATIVE_PATH RELATIVE_SOURCE "${ROOT_FOLDER}" "${FILE}")
        else()
            set(RELATIVE_SOURCE "${FILE}")
        endif()
        get_filename_component(SOURCE_PATH "${RELATIVE_SOURCE}" PATH)
        string(REPLACE "/" "\\" SOURCE_PATH_MSVC "${SOURCE_PATH}")
        source_group("${GROUP_NAME}\\${SOURCE_PATH_MSVC}" FILES "${FILE}")
    endforeach()
endfunction(ASSIGN_SOURCE_GROUPS)

# enable folders for MSVC

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realname=VulkanSceneGraph
pkgbase=mingw-w64-${_realname,,}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname,,}"
         "${MINGW_PACKAGE_PREFIX}-${_realname,,}-docs")
pkgver=1.1.8
pkgrel=1
pkgdesc="Vulkan & C++17 based Scene Graph Project (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='http://www.vulkanscenegraph.org/'
msys2_repository_url='https://github.com/vsg-dev/VulkanSceneGraph'
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-glslang"
         "${MINGW_PACKAGE_PREFIX}-vulkan-loader"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-winpthreads-git"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-graphviz")
# The '0001-vsg-1.1.3-devendor-glslang.patch' patch
# copied from https://github.com/microsoft/vcpkg/pull/38294
source=("${msys2_repository_url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        '0002-vsg-1.1.3-fix-win32-window.patch')
sha256sums=('94a3cebdfddf4759d17bbf0cc9f3278851eb899bdc660eb4681960e4cdd2ad6a'
            '2e6d8b0c2434a98eb67a70afb8643f109592dcea2e6afdbe2f6fe59e6783d792')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}
# =========================================== #

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    0002-vsg-1.1.3-fix-win32-window.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_{SHARED,STATIC}_LIBS=ON \
      -DVSG_SUPPORTS_ShaderCompiler=1 \
      -DGLSLANG_MIN_VERSION=15 \
      -DVSG_SUPPORTS_Windowing=1 \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}" --target docs
}

package_vulkanscenegraph() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE.md" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname,,}/LICENSE.md"
}

package_vulkanscenegraph-docs() {
  pkgdesc+=" (documentation)"
  depends=()

  mkdir -p "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname,,}"
  cp -r "build-${MSYSTEM}/html" "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname,,}/"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
